using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.IO;
using MeshVR;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;


namespace Censor
{
	public class Censor : MVRScript
    {
		protected string ASSETS_BUNDLE_PATH;
		protected Dictionary<string, GameObject> prefabObjects;
		public JSONStorableStringChooser faceChoices;
		public JSONStorableStringChooser upperChoices;
		public JSONStorableStringChooser lowerChoices;
		public JSONStorableStringChooser penisChoices;

		protected Material mat_mosaic;
		protected Material mat_black;
		public CensorData[] censors;

		public override void Init()
        {			 
            try
            {
				createStaticDescriptionText("Face options","<color=#000><size=35><b>FACE OPTIONS</b></size></color>",false,40);
				censors = new CensorData[4];
				censors[0] = new CensorData("Face", this, "AutoColliderAutoCollidersFaceHardLeft9", "AutoColliderAutoCollidersFaceHardRight9", true,
				 true, 6.0f, 200.0f, 420.0f, 0.2f, -0.04f, 0.07f, CensorData.modes[0]);
				createStaticDescriptionText("Upper options","<color=#000><size=35><b>UPPER OPTIONS</b></size></color>",false,40);
				censors[1] = new CensorData("Upper", this, "AutoColliderFemaleAutoColliderslNipple1", "AutoColliderFemaleAutoCollidersrNipple1", true,
				 false, 6.0f, 676.0f, 288.0f, 0.2f, 0.0f, 0.07f, CensorData.modes[1]);
				createStaticDescriptionText("Lower options","<color=#000><size=35><b>LOWER OPTIONS</b></size></color>",false,40);
				censors[2] = new CensorData("Lower", this, "AutoColliderpelvisFL1c", "AutoColliderpelvisFR1c", true,
				 false, 6.0f, 750.0f, 230.0f, 0.2f, 0.0f, 0.07f, CensorData.modes[1]);
				createStaticDescriptionText("Lower options","<color=#000><size=35><b>PENIS OPTIONS</b></size></color>",false,40);
				censors[3] = new CensorData("Penis", this, "AutoColliderGen1", "AutoColliderGen3b", true,
				 false, 6.0f, 600.0f, 300.0f, 0.2f, 0.0f, 0.1f, CensorData.modes[1]);
				createStaticDescriptionText("blank_space","",false,240);

				createStaticDescriptionText("Chooser options","<color=#000><size=30>Choose the type of censor. censor_circle is more of a face shape. censor_eyes and censor_face are semi-circles, not currently helpful. censor_stripe is a box. censor_stripe2 is a box with rounded edges</size></color>",true,240);

				// Start assetbundle load
				ASSETS_BUNDLE_PATH = GetPluginPath(this) + "/assets/mosaic_censor.assetbundle";	
				Request request = new AssetLoader.AssetBundleFromFileRequest {path = ASSETS_BUNDLE_PATH, callback = OnAssetBundleLoaded};
				AssetLoader.QueueLoadAssetBundleFromFile(request);
				
				prefabObjects = new Dictionary<string, GameObject>();

				mat_black = new Material(Shader.Find("Diffuse"));
				mat_black.color = new Color(0,0,0);				
			}
            catch(Exception e)
            {
                SuperController.LogError("Censor - Exception caught: " + e);
				if(ASSETS_BUNDLE_PATH != null) {
					AssetLoader.DoneWithAssetBundleFromFile(ASSETS_BUNDLE_PATH);
					ASSETS_BUNDLE_PATH = null;
				}
            }
		}

		private void OnAssetBundleLoaded(Request aRequest) {
			foreach (GameObject item in aRequest.assetBundle.LoadAllAssets<GameObject>())
			{
				prefabObjects.Add(item.name, item);
			}
			faceChoices = new JSONStorableStringChooser("face_censor_type", prefabObjects.Keys.ToList<string>(), "censor_circle", "Face Censor Type", censors[0].createCensor);
			CreatePopup(faceChoices, true);
			censors[0].createCensor(faceChoices.val);

			upperChoices = new JSONStorableStringChooser("upper_censor_type", prefabObjects.Keys.ToList<string>(), "censor_stripe", "Upper Censor Type", censors[1].createCensor);
			CreatePopup(upperChoices, true);
			censors[1].createCensor(upperChoices.val);

			lowerChoices = new JSONStorableStringChooser("lower_censor_type", prefabObjects.Keys.ToList<string>(), "censor_stripe", "Lower Censor Type", censors[2].createCensor);
			CreatePopup(lowerChoices, true);
			censors[2].createCensor(lowerChoices.val);

			penisChoices = new JSONStorableStringChooser("penis_censor_type", prefabObjects.Keys.ToList<string>(), "censor_stripe", "Penis Censor Type", censors[3].createCensor);
			CreatePopup(penisChoices, true);
			censors[3].createCensor(penisChoices.val);

			createStaticDescriptionText("Chooser options2","<color=#000><size=30>Use X and Y scale to change the size of the area censored</size></color>",true,80);
			createStaticDescriptionText("Chooser options3","<color=#000><size=30>Offset distance is the distance from the characters colliders that the censor will appear</size></color>",true,120);
			createStaticDescriptionText("Chooser options4","<color=#000><size=30>Vertical adjust allows for tweaking in relation to the attached points, however does not work as character rotates</size></color>",true,160);
			createStaticDescriptionText("Chooser options5","<color=#000><size=30>Attach modes: Fixed scale has the censor bar stay with a fixed x/y scale and can not handle angles. Resizing will scale the censor bar based on movement to attempt to keep areas covered, fixed horizontally.</size></color>",true,240);
		}

		public void Update() {
			foreach (CensorData c in censors) {
				c.update();
			}
		}
		
		public void OnDestroy() {
			if(ASSETS_BUNDLE_PATH != null) {
				AssetLoader.DoneWithAssetBundleFromFile(ASSETS_BUNDLE_PATH);
			}
			foreach (CensorData c in censors) {
				c.cleanup();
			}
		}

		public class CensorData {
			public string prefix;
			public Censor parentScript;
			public GameObject censorObj;
			
			public AutoCollider lCollider;
			public AutoCollider rCollider;

			public JSONStorableBool option_enable;
			public JSONStorableBool option_mosaic;
			public JSONStorableFloat option_pixelation;
			public JSONStorableFloat option_xScale;	
			public JSONStorableFloat option_yScale;		
			public JSONStorableFloat option_offsetDistance;
			public JSONStorableFloat option_verticalAdjust;
			public JSONStorableFloat option_borderSize;
			public JSONStorableStringChooser option_mode;
			public static readonly List<string> modes = new List<string>() {"Fixed Scale", "Resizing", "Experimental"};

			public CensorData(string prefix, Censor parentScript, string lColliderName, string rColliderName, bool default_enable, bool default_mosaic,
			float default_pixelation, float default_xScale, float default_yScale, float default_offsetDistance, float default_verticalAdjust, float default_border_size, string default_mode) {
				this.prefix = prefix;
				this.parentScript = parentScript;

				AutoCollider[] autoColliders = parentScript.containingAtom.GetComponentsInChildren<AutoCollider>();
				try{ 
					lCollider = autoColliders.First(ac => ac.name == lColliderName);
					rCollider = autoColliders.First(ac => ac.name == rColliderName);
				} catch(Exception e) {
					// SuperController.LogMessage("Could not find autocolliders: " + lColliderName + " " + rColliderName);
					// SuperController.LogMessage("Potentials: ");
					// foreach(AutoCollider col in autoColliders.Where(ac => ac.name.Contains(lColliderName))) {
					// 	SuperController.LogMessage("" + col.name);
					// }
					// foreach(AutoCollider col in autoColliders.Where(ac => ac.name.Contains(rColliderName))) {
					// 	SuperController.LogMessage("" + col.name);
					// }
					default_enable = false;
				}
				

				option_enable = new JSONStorableBool(prefix + " Enabled", default_enable, setEnable);
                parentScript.RegisterBool(option_enable);
                parentScript.CreateToggle(option_enable);

				option_mosaic = new JSONStorableBool(prefix + " Mosaic", default_mosaic, setMosaic);
                parentScript.RegisterBool(option_mosaic);
                parentScript.CreateToggle(option_mosaic);

				option_pixelation = new JSONStorableFloat(prefix + " Pixelation", default_pixelation, setPixelation, 1.0f, 1000.0f, true);
                parentScript.RegisterFloat(option_pixelation);
                parentScript.CreateSlider(option_pixelation);

				option_xScale = new JSONStorableFloat(prefix + " X Scale", default_xScale, setScale, 10.0f, 1000.0f, false);
                parentScript.RegisterFloat(option_xScale);
                parentScript.CreateSlider(option_xScale);

				option_yScale = new JSONStorableFloat(prefix + " Y Scale", default_yScale, setScale, 10.0f, 1000.0f, false);
                parentScript.RegisterFloat(option_yScale);
                parentScript.CreateSlider(option_yScale);

				option_offsetDistance = new JSONStorableFloat(prefix + " Offset Distance", default_offsetDistance, 0.0f, 10.0f, false);
                parentScript.RegisterFloat(option_offsetDistance);
                parentScript.CreateSlider(option_offsetDistance);

				option_verticalAdjust = new JSONStorableFloat(prefix + " Vertical Adjust", default_verticalAdjust, -1.0f, 1.0f, false);
                parentScript.RegisterFloat(option_verticalAdjust);
                parentScript.CreateSlider(option_verticalAdjust);

				option_borderSize = new JSONStorableFloat(prefix + " Border Size", default_border_size, -1.0f, 1.0f, false);
                parentScript.RegisterFloat(option_borderSize);
                parentScript.CreateSlider(option_borderSize);

				option_mode = new JSONStorableStringChooser(prefix + " Mode", modes, default_mode, prefix + " Attach Mode", setScale);
				parentScript.CreatePopup(option_mode);
			}

			public void createCensor(string prefabName){
			if (censorObj != null) {
				Destroy(censorObj);
				censorObj = null;
			}
			censorObj = Instantiate(parentScript.prefabObjects[prefabName]);
			parentScript.mat_mosaic = censorObj.GetComponent<MeshRenderer>().material;
			censorObj.GetComponent<MeshRenderer>().shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.Off;

			// Call dummy values, callbacks grab the paramter value no matter what
			setMosaic(true);
			setEnable(true);
			setScale(0.0f);
			setPixelation(0.01f);
		}

			private void setEnable(bool b) {
				censorObj.GetComponent<MeshRenderer>().enabled = option_enable.val;
			}
			public void setMosaic(bool mosaic) {
				if(parentScript.mat_mosaic != null && censorObj != null) {
					if(option_mosaic.val) {
						censorObj.GetComponent<MeshRenderer>().material = parentScript.mat_mosaic;
					} else {
						censorObj.GetComponent<MeshRenderer>().material = parentScript.mat_black;
					}
				}
			}
			private void setScale(string f) {
				setScale(0.0f);
			}
			private void setScale(float f) {
				censorObj.transform.localScale = new Vector3(option_xScale.val, option_yScale.val, 100.0f);
			}
			public void setPixelation(float f) {
				if (censorObj != null) {
					censorObj.GetComponent<MeshRenderer>().material.SetFloat ("_Pixelation", option_pixelation.val / 1000.0f);
				}
			}

			public void update(){
				if(censorObj != null && option_enable.val) {
					if(option_mode.val.Equals(modes[1])) {
						Vector3 cam = CameraTarget.centerTarget.transform.position;
						Vector3 l1 = cam - lCollider.anchorTarget;
						Vector3 r1 = cam - rCollider.anchorTarget;
						float minDistance = Math.Min(r1.magnitude, l1.magnitude) - option_offsetDistance.val;
						Vector3 lp = cam + (l1.normalized * minDistance);
						Vector3 rp = cam + (r1.normalized * minDistance);
						Vector3 diff = rp - lp;
						float yDiff = Math.Abs(diff.y) + option_borderSize.val;
						diff.y = 0.0f;
						float xzDiff = diff.magnitude + option_borderSize.val;
						censorObj.transform.localScale = new Vector3(option_xScale.val * (xzDiff / 0.33f), option_yScale.val * (yDiff / 0.33f), 100.0f);
					}

					Vector3 adjustedPos = (lCollider.anchorTarget + rCollider.anchorTarget) / 2 + new Vector3(0, option_verticalAdjust.val, 0);
					Vector3 pathVector = adjustedPos - CameraTarget.centerTarget.transform.position;
					Vector3 unitVector = pathVector.normalized;

					censorObj.transform.position = adjustedPos - unitVector * option_offsetDistance.val;
					Vector3 lookPos = CameraTarget.centerTarget.transform.position - censorObj.transform.position;
					Quaternion lookRot = Quaternion.LookRotation(lookPos, Vector3.up);
					float eulerX = lookRot.eulerAngles.x;
					float eulerY = lookRot.eulerAngles.y;
					Quaternion rotation = Quaternion.Euler (eulerX, eulerY, 0);
					
					censorObj.transform.rotation = rotation;

					if(option_mode.val.Equals(modes[2])) {
						Vector3 cam = CameraTarget.centerTarget.transform.position;
						Vector3 l1 = cam - lCollider.anchorTarget;
						Vector3 r1 = cam - rCollider.anchorTarget;
						float minDistance = Math.Min(r1.magnitude, l1.magnitude) - option_offsetDistance.val;
						Vector3 lp = cam + (l1.normalized * minDistance);
						Vector3 rp = cam + (r1.normalized * minDistance);
						Vector3 diff = rp - lp;
						
						Quaternion objRot = Quaternion.LookRotation(diff, Vector3.up) * Quaternion.Euler(0.0f, 90.0f, 0.0f);
						censorObj.transform.rotation = rotation * objRot;
					}
				}
			}
			public void cleanup() {
				if (censorObj != null) {
					Destroy(censorObj);
					censorObj = null;
				}	
			}

			~CensorData() {
				cleanup();
			}
		}
		
		/**** From MacGruber_utils.cs ****/
		// Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.
		public static string GetPluginPath(MVRScript self)
		{
			string id = self.name.Substring(0, self.name.IndexOf('_'));
			string filename = self.manager.GetJSON()["plugins"][id].Value;
			return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
		}
		private static void disableScrollOnText(UIDynamicTextField target) {
			ScrollRect targetSR = target.UItext.transform.parent.transform.parent.transform.parent.GetComponent<ScrollRect>();
			if( targetSR != null ) {
				targetSR.horizontal = false;
				targetSR.vertical = false;
			}
		}
		private void createStaticDescriptionText( string DescTitle, string DescText, bool rightSide, int fieldHeight ) {
			JSONStorableString staticDescString = new JSONStorableString(DescTitle,DescText);
			UIDynamicTextField staticDescStringField = CreateTextField(staticDescString, rightSide);
			staticDescStringField.backgroundColor = new Color(1f, 1f, 1f, 0f);
			LayoutElement sdsfLayout = staticDescStringField.GetComponent<LayoutElement>();
			sdsfLayout.preferredHeight = sdsfLayout.minHeight = fieldHeight;
			staticDescStringField.height = fieldHeight;
			disableScrollOnText(staticDescStringField);
		}
	}
}